
import type { Config } from '../conf';
import type { Metadata } from '../metadata';
import type { ColorTheme } from '@doc-utils/color-themes';
import type { SitemapEntry } from './sitemap';
import { RSSEntry } from './rss';
import { EventEntry, EventSeries } from './icalendar';
import { ContextTime } from '../template';

export interface BuildState {
	conf: Config;
	seen_files: Set<string>;
	env: Record<string, string>;
	partials?: Record<string, string>;
	layouts: Record<string, string>;
	themes: Record<string, ColorTheme>;
	theme_groups: ThemeGroups;
	extras: Record<string, string>;
	made_directories: Set<string>;
	old_metadata: Metadata;
	new_metadata: Metadata;
	rss: RSSEntry[][];
	sitemap: SitemapEntry[];
	events: EventEntry[];
	event_series: EventSeries[];
	calendars: EventEntry[][];
	build_time: ContextTime;
}

export interface ThemeGroups {
	all: ColorTheme[];
	light: ColorTheme[];
	dark: ColorTheme[];
	high_contrast: ColorTheme[];
	low_contrast: ColorTheme[];
	monochrome: ColorTheme[];
	greyscale: ColorTheme[];
	protanopia_safe: ColorTheme[];
	deuteranopia_safe: ColorTheme[];
	tritanopia_safe: ColorTheme[];
}
